"{ Encoding: utf8 }"

"{ Package: 'stx:libwidg2/tests' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#TerminalViewTests
	instanceVariableNames:'topView terminalView textViewInteractor'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-TerminalViews-Tests'
!


!TerminalViewTests methodsFor:'running'!

setUp
    Screen current isNil ifTrue:[
        Smalltalk openDisplay.
    ].
    self skipIf:Screen current isNil description:'No display connection'.
    Smalltalk loadPackage:'stx:goodies/sunit/ext/ui'.
    super setUp.

    topView := StandardSystemView new.
    topView extent: (topView font maxWidth * 80) @ 200.
    topView label: self printString.
    terminalView := TerminalView origin: 0.0@0.0 extent: 1.0@1.0 in: topView.
    terminalView shellTerminateAction:[  ].

    textViewInteractor := terminalView interactor.

    topView open.
    topView waitUntilVisible.

    "Modified: / 14-06-2019 / 12:31:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

tearDown
    terminalView topView destroy.
    MessageTracer unmock: #current  in: UserPreferences class

    "Created: / 23-07-2014 / 07:17:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 12-10-2017 / 22:59:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TerminalViewTests methodsFor:'tests - regression'!

test_unicode_01a_u
    | file blocker |

    self skipIf: OperatingSystem isUNIXlike not description: 'This test is UNIX specific'.

    file := Filename newTemporary.
    [ 
        file writingFileDo:[:s|
            s binary.
            s nextPutAll: 'Příliš žluťoučký kůň úpěl ďábelské ódy.' utf8Encoded
        ].
        blocker := Semaphore new.
        terminalView shellTerminateAction:[ blocker signal ].
        terminalView startCommand: ('cat %1' bindWith: file pathName).
        blocker waitWithTimeoutMs: 10000.  

        self assert: (terminalView list first = 'Příliš žluťoučký kůň úpěl ďábelské ódy.')
    ] ensure:[
        file remove.
    ]

    "Created: / 14-06-2019 / 12:15:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TerminalViewTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

